#include <stdio.h>
#include <stdlib.h>

typedef struct tuple_t tuple_t;
struct tuple_t {
	tuple_t *a, *b;
};

extern tuple_t *thai(tuple_t *t);

static int tuple_to_int(tuple_t *t) {
	if(t == NULL) return 0;
	return 1 + tuple_to_int(t->b);
}

static tuple_t *int_to_tuple(int n) {
	int i;
	tuple_t *t;

	t = malloc(n * sizeof(*t));
	for(i=0; i<n-1; i++) {
		t[i].a = NULL;
		t[i].b = t+(i+1);
	}
	t[n-1].a = NULL;
	t[n-1].b = NULL;
	return t;
}

static int print_list(tuple_t *t) {
	printf("%d", tuple_to_int(t->a));
	if(t->b != NULL) {
		putchar(' ');
		print_list(t->b);
	}
}

int main(int argc, char **argv) {
	tuple_t *t;
	if(argc != 2) {
		fprintf(stderr, "%s <integer>\n", argv[0]);
		return 1;
	}
	t = thai(int_to_tuple(atoi(argv[1])));
	putchar('[');
	print_list(t);
	putchar(']');
	putchar('\n');
	return 0;
}

